<script setup lang="ts">
import { storeToRefs } from 'pinia'
import type { PollType } from '~/store/poll'
import { usePollStore } from '~/store/poll'
import { useUIStore } from '~~/store/UI'

interface Props {
  question: PollType
  id: string
  push: Function
}
const { question, id: key, push } = defineProps<Props>()
const emit = defineEmits(['push'])
const ui = useUIStore()
const { isDesign7 } = storeToRefs(ui)
const poll = usePollStore()

const styleModal = ref(true)
let ans = $ref('')

const notifyEvent = inject('notifyEvent') as any[]

const submitPoll = () => {
  poll.votePoll(ans)
  poll.answeredQues.push(key)
  ans = ''
  emit('push', { tab: 'poll', value: -1 })
}
</script>

<template>
  <!-- Main modal -->
  <div
    id="medium-modal" tabindex="-1"
    class="fixed inset-0 z-40 border border-current " :class="styleModal ? '' : 'hidden'"
  >
    <!-- Modal content -->
    <div class="relative top-1/2 left-1/2 background-modal max-w-1/3 lt-sm:max-w-3/4 translate-x--1/2 translate-y--1/2 text-white">
      <!-- Modal header -->
      <div :class="isDesign7 ? 'p-3' : 'p-5'" class="flex justify-between items-center rounded-t border-b dark:border-gray-600">
        <h3 class="text-xl lt-sm:text-base font-bold dark:text-white">
          新規アンケート
        </h3>
        <button
          type="button"
          class="text-gray-400 bg-transparent bg-white hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 lt-sm:p-1 ml-auto inline-flex items-center dark:hover:bg-gray-600 dark:hover:text-white"
          data-modal-toggle="medium-modal" @click="styleModal = false"
        >
          <svg
            aria-hidden="true" class="w-5 h-5" fill="currentColor" viewBox="0 0 20 20"
            xmlns="http://www.w3.org/2000/svg"
          >
            <path
              fill-rule="evenodd"
              d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z"
              clip-rule="evenodd"
            />
          </svg>
          <span class="sr-only">Close modal</span>
        </button>
      </div>
      <!-- Modal body -->
      <h1 :class="isDesign7 ? 'p-y-0 text-2xl' : 'p-y-3 text-3xl'" class="p-x-6 flex lt-sm:text-xl font-medium justify-start text-left break-all">
        {{ question.question }}
      </h1>
      <div :class="isDesign7 ? 'min-h-[50vh] p-4' : 'p-6'" class="space-y-6 flex flex-col justify-start min-h-[225px]">
        <div v-for="value in question.Answer" :key="value.id" class="flex items-center gap-2">
          <input :id="`modal_${value.id}`" v-model="ans" :value="value.id" type="radio" :name="question.question" class="text-label cursor-pointer">
          <label :for="`modal_${value.id}`" :class="isDesign7 ? 'text-xl' : 'text-2xl'" class=" lt-sm:text-lg text-label cursor-pointer text-left break-all font-normal">
            {{ value.answer }}
          </label>
        </div>
      </div>
      <!-- Modal footer -->
      <div :class="isDesign7 ? 'p-2' : 'p-6'" class="flex justify-end items-center lt-sm:p-4 space-x-2 rounded-b border-t border-gray-200 dark:border-gray-600">
        <button
          data-modal-toggle="medium-modal" type="button" class="px-4 py-2 text-lg lt-sm:px-2 lt-sm:py-1 lt-sm:text-base bg-blue-600 hover:bg-blue-400 text-white rounded-md cursor-pointer"
          :disabled="!ans" @click="() => submitPoll()"
        >
          送信
        </button>
      </div>
    </div>
  </div>
</template>

<style scoped>
.background-modal {
  background-image: url('/images/background-modal.jpg');
   background-size: cover;
}
.text-label{
  margin: 0 !important;
}
h3 {
  margin: 5px;
}
</style>
